/* This file is part of the Allegria project
   Copyright (C) 2004 Francois Schiettekatte <francois.schiettekatte@umontreal.ca>

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; see the file COPYING.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.
*/

#ifndef ELEMPARAM_H
#define ELEMPARAM_H


#include <qhbox.h>
#include <qvbox.h>
#include <qcombobox.h>
#include <qlineedit.h>
#include <qpushbutton.h>

#include "../XYQt/PeriodicTable.h"
#include "FormElementParam.h"

class ExperimentalSetupImpl;

struct ElementParam {
	Atom atom;
	double angle;
	double ratio;
	QString absorber;
	double thickness;
	double slope;
	double zero;
	double Arho;
	QString detec;
	QString file;
};


class ElementParamWidget : public FormElementParam
{
    Q_OBJECT

public:
	ElementParamWidget(ElementParam par, ExperimentalSetupImpl * pparent = 0, const char* name = 0);
	ElementParam getParams();

private:
	ExperimentalSetupImpl * parent;

	Atom detectedElement;
	Atom absorberElement;

private slots:
	void setElement();
	void setAbsorber();
	void setParams(ElementParam par);
	void setCalib(int sel);
        void doFindFile();
};


#endif // ELEMPARAM_H
