// algorithm to find if a point sits inside a polygon
// by Wm. Randolph Franklin (www.ecse.rpi.edu/Homepages/wrf/misc_notes/pnpoly.html)

#ifndef PNPOLY_H
#define PNPOLY_H

// x, y: point coordinates
// xp[], yp[]: npol coordinates of polygon vertex

// returns true if point is inside, false otherwise
bool pnpoly(int npol, double *xp, double *yp, double x, double y)
    {
      int i, j;
	  bool c = false;
      for (i = 0, j = npol-1; i < npol; j = i++) {
        if ((((yp[i]<=y) && (y<yp[j])) ||
             ((yp[j]<=y) && (y<yp[i]))) &&
            (x < (xp[j] - xp[i]) * (y - yp[i]) / (yp[j] - yp[i]) + xp[i]))

          c = !c;
      }
      return c;
    }

#endif //PNPOLY_H

